    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.interaction;
    034
    035import java.util.Set;
    036import java.util.TreeSet;
    037import java.util.Collection;
    038import org.jfree.chart3d.data.xyz.XYZDataset;
    039import org.jfree.chart3d.data.xyz.XYZItemKey;
    040import org.jfree.chart3d.internal.Args;
    041
    042/**
    043 * An object that tracks selected items from an {@link XYZDataset}.
    044 *
    045 * @param <S> S
    046 *
    047 * @since 1.3
    048 */
    049public class StandardXYZDataItemSelection<S> implements XYZDataItemSelection {
    050
    051    /** The selected items. */
    052    Set<XYZItemKey> selectedItems;
    053
    054    /**
    055     * Creates a new (empty) selection.
    056     */
    057    public StandardXYZDataItemSelection() {
    058        this.selectedItems = new TreeSet<>();
    059    }
    060
    061    /**
    062     * Adds an item to the selection, returns {@code true} if the item
    063     * was added and {@code false} if it already existed in the selection.
    064     *
    065     * @param item  the item key ({@code null} not permitted).
    066     *
    067     * @return A boolean.
    068     */
    069    public boolean add(XYZItemKey item) {
    070        Args.nullNotPermitted(item, "item");
    071        return this.selectedItems.add(item);
    072    }
    073
    074    /**
    075     * Adds all the items from the specified collection, returning
    076     * {@code true} if the selection is updated or {@code false} if
    077     * all the supplied keys are already present in the selection.
    078     *
    079     * @param keys  the keys ({@code null} not permitted).
    080     *
    081     * @return A boolean.
    082     */
    083    public boolean addAll(Collection<XYZItemKey> keys) {
    084        Args.nullNotPermitted(keys, "keys");
    085        return this.selectedItems.addAll(keys);
    086    }
    087
    088    /**
    089     * Removes an item from the selection, returning {@code true} if the
    090     * item was removed and {@code false} if it was not present in the
    091     * selection.
    092     *
    093     * @param item  the item ({@code null} not permitted).
    094     *
    095     * @return A boolean.
    096     */
    097    public boolean remove(XYZItemKey item) {
    098        return this.selectedItems.remove(item);
    099    }
    100
    101    /**
    102     * Returns {@code true} if the item is present in the selection,
    103     * and {@code false} otherwise.
    104     *
    105     * @param item  the item {@code null} not permitted).
    106     *
    107     * @return A boolean.
    108     */
    109    @Override
    110    public boolean isSelected(XYZItemKey item) {
    111        return this.selectedItems.contains(item);
    112    }
    113
    114    /**
    115     * Clears the selection.
    116     */
    117    public void clear() {
    118        this.selectedItems.clear();
    119    }
    120
    121}